<?
require("$_SERVER[DOCUMENT_ROOT]/lib/php/base.php");

$usernameFromApi = value($_SESSION, 'usernameFromApi', NULL);
$passwordFromApi = value($_SESSION, 'passwordFromApi', NULL);
$authOk    = false;
$msg       = '';
$sessid    = session_id();
$_login    = reqval('login', $usernameFromApi);
$_passwd   = reqval('passwd', $passwordFromApi);
$_format   = reqval('fmt', NULL);
$_callback = reqval('callback', NULL);
$__id      = reqval('_id', NULL);

Trace("login=$_login");
if ($_login != NULL && $_passwd != NULL)
    $authOk = authenticate($_login, $_passwd, $msg);
else
    $msg = "&msg=".rawurlencode(gettext("ErrEmptyFields"));

if ($authOk)
{
    $output = array(
	'login'  => 1,
	'sessid' => $sessid,
	'begin'  => (int) $_SESSION['SessionBegin'],
	'view'   => (int) $_SESSION['CamPort'],
	'ctrl'   => (int) $_SESSION['CtrlPort'],
	'play'   => (int) $_SESSION['PlayPort'],
	'ws_ctrl' => true,
	'ws_scheme' => $_SESSION['control']['scheme'],
	'ws_port' => $_SESSION['control']['port'],
	'ws_base' => $_SESSION['control']['base'],
	'ws_url' => $_SESSION['control']['url']
    );
}
else
{
    $output = array(
	'login' => 0
    );
    session_destroy();
}

switch ($_format)
{
    case 'txt':
    {
	header("Expires: Tue, 01 Jan 1980 00:00:00 GMT");
	header("Cache-Control: no-cache");
	header("Pragma: no-cache");
	header("Content-type: text/plain");

	$sep = '|';
	foreach ($output as $key => $value)
	    echo $key.$sep.$value."\n";
	exit;
    }

    case 'json':
    {
	header('Expires: Tue, 01 Jan 1980 00:00:00 GMT');
	header('Cache-Control: no-cache');
	header('Pragma: no-cache');

	if ($_callback)
	{
	    header('Content-Type: text/javascript');
	    echo htmlentities($_callback).'('.json_encode($output).')';
	}
	else
	{
	    header('Content-Type: application/x-json');
	    echo json_encode($output);
	}
	exit;
    }

    default:
    {
	if ($__id)
	{
	    header("Expires: Tue, 01 Jan 1980 00:00:00 GMT");
	    header("Cache-Control: no-cache");
	    header("Pragma: no-cache");
	    header("Content-Type: text/javascript");?>
(function()
{
var obj = Script.done(<?=htmlentities($__id)?>);

obj.sessid = '<?=($output['login'] == 1) ? $output['sessid'] : ''?>';
obj.begin = <?=$_SESSION['SessionBegin']?>;
obj.ws_ctrl = <?=$output['ws_ctrl']?>;
obj.ws_scheme = '<?=$output['ws_scheme']?>';
obj.ws_port = <?=$output['ws_port']?>;
obj.ws_base = '<?=$output['ws_base']?>';
obj.ws_url = '<?=$output['ws_url']?>';
})();
<?          exit;
	}
    }
}

if (isset($_GET['auth']))	// Old-style simple authentication
{
    if (empty($_GET['auth']))	// No auth URL: just teach scamd to the browser
    {
	if ($authOk)
	    $url = $_SESSION['Srvs'][0]['viewHost']."/x?sessid=$sessid";
	else
	    $url = "/login/error.php";
    }
    else
	$url = $_GET['auth']."?user=".htmlspecialchars($_login)."&pass=".htmlspecialchars($_passwd)."&auth=".$_SESSION['LogedIn'];

    header("Location: $url");
    exit();
}

if (!$authOk) :
?>
<html>
<header></header>
<body onload="document.forms['redirect'].submit();">
<form name="redirect" method="post" action="/login/login.php">
	<input type="hidden" name="login" value="<?=htmlspecialchars($_login)?>"/>
	<input type="hidden" name="msg" value="<?=htmlspecialchars($msg)?>"/>
</form>
</body>
</html>
<?
	exit();
endif;

if (isset($_GET['map']))
    $arg = "?map=".$_GET['map'];
elseif (isset($_GET['group']))
    $arg = "?group=".$_GET['group'];
elseif (isset($_GET['camera']))
    $arg = "?camera=".$_GET['camera'];
elseif (isset($_GET['desk']))
    $arg = "?desk=".$_GET['desk'];
else
    $arg = "";

DocType();
?>
<html>
    <head>
<?
        Entetes(HDR_NOCACHE);
        include("$_SERVER[DOCUMENT_ROOT]/lib/js/resize.php");
?>
        <script type="text/javascript">
        function frames()
        {
	    if (top.name != '')
	    {
		var sz = resize_to(<?=MAIN_MENU_W?>,<?=MAIN_MENU_H?>);
		top.moveTo((screen.width - sz.w) / 2, 20);
	    }
            top.location.href = "/frames.php<?=htmlspecialchars($arg)?>";
        }

<?	if (isset($_GET['opnr']) && empty($_GET['opnr'])) { ?>
	window.onload = frames;
<?	} else { ?>
	window.onload = function () {
	    if (opener && (typeof opener.closed) != "unknown" && !opener.closed) {
		opener.location.href = "/index.php<?=htmlspecialchars($arg)?>";
		if (window.name == '_api')
		    window.close();
	    } else {
		frames();
	    }
	};
<?	} ?>
        </script>
    </head>
    <body bgcolor="#FFFFFF"></body>
</html>